From f84d86e6e36f52d3ee27f2151d5e2bbe05ffddae Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Aur=C3=A9lien=20G=C3=A2teau?= <agateau@kde.org>
Date: Wed, 16 Oct 2013 14:45:00 +0200
Subject: [PATCH 1/4] Move plugin handling to kmessagebox_p.*

---
 tier1/kwidgetsaddons/src/CMakeLists.txt    |   1 +
 tier1/kwidgetsaddons/src/kmessagebox.cpp   |  69 +-------------------
 tier1/kwidgetsaddons/src/kmessagebox.h     |   2 +
 tier1/kwidgetsaddons/src/kmessagebox_p.cpp | 100 +++++++++++++++++++++++++++++
 tier1/kwidgetsaddons/src/kmessagebox_p.h   |  31 +++++++++
 5 files changed, 135 insertions(+), 68 deletions(-)
 create mode 100644 tier1/kwidgetsaddons/src/kmessagebox_p.cpp
 create mode 100644 tier1/kwidgetsaddons/src/kmessagebox_p.h

diff --git a/tier1/kwidgetsaddons/src/CMakeLists.txt b/tier1/kwidgetsaddons/src/CMakeLists.txt
index 50c578a..064945a 100644
--- a/tier1/kwidgetsaddons/src/CMakeLists.txt
+++ b/tier1/kwidgetsaddons/src/CMakeLists.txt
@@ -18,6 +18,7 @@ set(kwidgetsaddons_SRCS
   kguiitem.cpp
   kled.cpp
   kmessagebox.cpp
+  kmessagebox_p.cpp
   kmultitabbar.cpp
   kstandardguiitem.cpp
   kurllabel.cpp # Not good enough quality. Needs to use QUrl instead of QString and should not inherit QLabel, but hold it as a member instead.
diff --git a/tier1/kwidgetsaddons/src/kmessagebox.cpp b/tier1/kwidgetsaddons/src/kmessagebox.cpp
index b2345d0..1cb18f0 100644
--- a/tier1/kwidgetsaddons/src/kmessagebox.cpp
+++ b/tier1/kwidgetsaddons/src/kmessagebox.cpp
@@ -19,7 +19,7 @@
 */
 
 #include "kmessagebox.h"
-#include "kmessageboxdontaskagaininterface.h"
+#include "kmessagebox_p.h"
 
 #include <QtCore/QPointer>
 #include <QCheckBox>
@@ -34,7 +34,6 @@
 #include <QScrollArea>
 #include <QScrollBar>
 #include <QTextDocumentFragment>
-#include <QPluginLoader>
 #include <QTextBrowser>
 #include <QWindow>
 
@@ -450,72 +449,6 @@ ButtonCode questionYesNo(QWidget *parent, const QString &text,
                             buttonYes, buttonNo, dontAskAgainName, options);
 }
 
-class KMessageBoxDontAskAgainMemoryStorage : public KMessageBoxDontAskAgainInterface
-{
-public:
-    KMessageBoxDontAskAgainMemoryStorage() {}
-    virtual ~KMessageBoxDontAskAgainMemoryStorage() {}
-
-    virtual bool shouldBeShownYesNo(const QString &dontShowAgainName, KMessageBox::ButtonCode &result) {
-        KMessageBox::ButtonCode code = m_saved.value(dontShowAgainName, KMessageBox::ButtonCode(0));
-        if (code == KMessageBox::Yes || code == KMessageBox::No) {
-            result = code;
-            return false;
-        }
-        return true;
-    }
-    virtual bool shouldBeShownContinue(const QString &dontShowAgainName) {
-        KMessageBox::ButtonCode code = m_saved.value(dontShowAgainName, KMessageBox::Yes);
-        return code == KMessageBox::Yes;
-    }
-    virtual void saveDontShowAgainYesNo(const QString &dontShowAgainName, KMessageBox::ButtonCode result) {
-        m_saved[dontShowAgainName] = result;
-    }
-    virtual void saveDontShowAgainContinue(const QString &dontShowAgainName) {
-        m_saved[dontShowAgainName] = KMessageBox::No;
-    }
-    virtual void enableAllMessages() {
-        m_saved.clear();
-    }
-    virtual void enableMessage(const QString& dontShowAgainName) {
-        m_saved.remove(dontShowAgainName);
-    }
-    virtual void setConfig(KConfig *) {}
-
-private:
-    QHash<QString, KMessageBox::ButtonCode> m_saved;
-};
-
-// TODO should we use QSharedPointer here?
-static KMessageBoxDontAskAgainInterface* s_dontAskAgainInterface = 0;
-static KMessageBoxDontAskAgainInterface* dontAskAgainInterface() {
-    if (!s_dontAskAgainInterface) {
-        static bool triedLoadingPlugin = false;
-        if (!triedLoadingPlugin) {
-            triedLoadingPlugin = true;
-
-            QPluginLoader lib(QStringLiteral("kf5/frameworkintegrationplugin"));
-            QObject* rootObj = lib.instance();
-            if (rootObj) {
-                s_dontAskAgainInterface = rootObj->property(KMESSAGEBOXDONTASKAGAIN_PROPERTY).value<KMessageBoxDontAskAgainInterface *>();
-            }
-        }
-        // TODO use Qt-5.1's Q_GLOBAL_STATIC
-        if (!s_dontAskAgainInterface) {
-            s_dontAskAgainInterface = new KMessageBoxDontAskAgainMemoryStorage;
-        }
-    }
-    return s_dontAskAgainInterface;
-}
-
-void setDontShowAgainInterface(KMessageBoxDontAskAgainInterface* dontAskAgainInterface)
-{
-    Q_ASSERT(dontAskAgainInterface != 0);
-    // FIXME should we delete s_dontAskAgainInterface before? Or perhaps use smart pointers to avoid problems?
-    s_dontAskAgainInterface = dontAskAgainInterface;
-}
-
-
 bool shouldBeShownYesNo(const QString &dontShowAgainName,
                                      ButtonCode &result)
 {
diff --git a/tier1/kwidgetsaddons/src/kmessagebox.h b/tier1/kwidgetsaddons/src/kmessagebox.h
index 9a76c23..f7ebe51 100644
--- a/tier1/kwidgetsaddons/src/kmessagebox.h
+++ b/tier1/kwidgetsaddons/src/kmessagebox.h
@@ -789,6 +789,8 @@ namespace KMessageBox
 
     /**
      * Use @p dontAskAgainInterface for all settings related to the donShowAgain feature
+     *
+     * @since 5.0
      */
     KWIDGETSADDONS_EXPORT void setDontShowAgainInterface(KMessageBoxDontAskAgainInterface* dontAskAgainInterface);
 
diff --git a/tier1/kwidgetsaddons/src/kmessagebox_p.cpp b/tier1/kwidgetsaddons/src/kmessagebox_p.cpp
new file mode 100644
index 0000000..77a6aac
--- /dev/null
+++ b/tier1/kwidgetsaddons/src/kmessagebox_p.cpp
@@ -0,0 +1,100 @@
+/*  This file is part of the KDE libraries
+ *  Copyright 2012 David Faure <faure+bluesystems@kde.org>
+ *  Copyright 2013 Aurélien Gâteau <agateau@kde.org>
+ *
+ *  This library is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU Lesser General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License or ( at
+ *  your option ) version 3 or, at the discretion of KDE e.V. ( which shall
+ *  act as a proxy as in section 14 of the GPLv3 ), any later version.
+ *
+ *  This library is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *  Library General Public License for more details.
+ *
+ *  You should have received a copy of the GNU Lesser General Public License
+ *  along with this library; see the file COPYING.LIB.  If not, write to
+ *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
+ */
+#include "kmessagebox_p.h"
+
+#include <QPluginLoader>
+#include <QVariant>
+
+namespace KMessageBox {
+
+class KMessageBoxDontAskAgainMemoryStorage : public KMessageBoxDontAskAgainInterface
+{
+public:
+    KMessageBoxDontAskAgainMemoryStorage() {}
+    virtual ~KMessageBoxDontAskAgainMemoryStorage() {}
+
+    virtual bool shouldBeShownYesNo(const QString &dontShowAgainName, KMessageBox::ButtonCode &result) {
+        KMessageBox::ButtonCode code = m_saved.value(dontShowAgainName, KMessageBox::ButtonCode(0));
+        if (code == KMessageBox::Yes || code == KMessageBox::No) {
+            result = code;
+            return false;
+        }
+        return true;
+    }
+    virtual bool shouldBeShownContinue(const QString &dontShowAgainName) {
+        KMessageBox::ButtonCode code = m_saved.value(dontShowAgainName, KMessageBox::Yes);
+        return code == KMessageBox::Yes;
+    }
+    virtual void saveDontShowAgainYesNo(const QString &dontShowAgainName, KMessageBox::ButtonCode result) {
+        m_saved[dontShowAgainName] = result;
+    }
+    virtual void saveDontShowAgainContinue(const QString &dontShowAgainName) {
+        m_saved[dontShowAgainName] = KMessageBox::No;
+    }
+    virtual void enableAllMessages() {
+        m_saved.clear();
+    }
+    virtual void enableMessage(const QString& dontShowAgainName) {
+        m_saved.remove(dontShowAgainName);
+    }
+    virtual void setConfig(KConfig *) {}
+
+private:
+    QHash<QString, KMessageBox::ButtonCode> m_saved;
+};
+
+// TODO should we use QSharedPointer here?
+static KMessageBoxDontAskAgainInterface* s_dontAskAgainInterface = 0;
+
+static void loadKMessageBoxPlugin()
+{
+    static bool triedLoadingPlugin = false;
+    if (!triedLoadingPlugin) {
+        triedLoadingPlugin = true;
+
+        QPluginLoader lib(QStringLiteral("kf5/frameworkintegrationplugin"));
+        QObject *rootObj = lib.instance();
+        if (rootObj) {
+            s_dontAskAgainInterface = rootObj->property(KMESSAGEBOXDONTASKAGAIN_PROPERTY).value<KMessageBoxDontAskAgainInterface *>();
+        }
+    }
+    // TODO use Qt-5.1's Q_GLOBAL_STATIC
+    if (!s_dontAskAgainInterface) {
+        s_dontAskAgainInterface = new KMessageBoxDontAskAgainMemoryStorage;
+    }
+}
+
+KMessageBoxDontAskAgainInterface *dontAskAgainInterface()
+{
+    if (!s_dontAskAgainInterface) {
+        loadKMessageBoxPlugin();
+    }
+    return s_dontAskAgainInterface;
+}
+
+void setDontShowAgainInterface(KMessageBoxDontAskAgainInterface* dontAskAgainInterface)
+{
+    Q_ASSERT(dontAskAgainInterface != 0);
+    // FIXME should we delete s_dontAskAgainInterface before? Or perhaps use smart pointers to avoid problems?
+    s_dontAskAgainInterface = dontAskAgainInterface;
+}
+
+} // KMessageBox namespace
diff --git a/tier1/kwidgetsaddons/src/kmessagebox_p.h b/tier1/kwidgetsaddons/src/kmessagebox_p.h
new file mode 100644
index 0000000..77948ad
--- /dev/null
+++ b/tier1/kwidgetsaddons/src/kmessagebox_p.h
@@ -0,0 +1,31 @@
+/*  This file is part of the KDE libraries
+ *  Copyright 2013 Aurélien Gâteau <agateau@kde.org>
+ *
+ *  This library is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU Lesser General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License or ( at
+ *  your option ) version 3 or, at the discretion of KDE e.V. ( which shall
+ *  act as a proxy as in section 14 of the GPLv3 ), any later version.
+ *
+ *  This library is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *  Library General Public License for more details.
+ *
+ *  You should have received a copy of the GNU Lesser General Public License
+ *  along with this library; see the file COPYING.LIB.  If not, write to
+ *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
+ */
+#ifndef KMESSAGEBOX_P_H
+#define KMESSAGEBOX_P_H
+
+#include <kmessageboxdontaskagaininterface.h>
+
+namespace KMessageBox {
+
+KMessageBoxDontAskAgainInterface *dontAskAgainInterface();
+
+} // KMessageBox
+
+#endif /* KMESSAGEBOX_P_H */
-- 
1.8.1.2


From ea0f9bdf88d46e09251be13b5d297215d524590f Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Aur=C3=A9lien=20G=C3=A2teau?= <agateau@kde.org>
Date: Wed, 16 Oct 2013 15:32:06 +0200
Subject: [PATCH 2/4] Fix path to integration plugin

---
 tier1/kwidgetsaddons/src/kmessagebox_p.cpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/tier1/kwidgetsaddons/src/kmessagebox_p.cpp b/tier1/kwidgetsaddons/src/kmessagebox_p.cpp
index 77a6aac..81a0bf6 100644
--- a/tier1/kwidgetsaddons/src/kmessagebox_p.cpp
+++ b/tier1/kwidgetsaddons/src/kmessagebox_p.cpp
@@ -70,7 +70,7 @@ static void loadKMessageBoxPlugin()
     if (!triedLoadingPlugin) {
         triedLoadingPlugin = true;
 
-        QPluginLoader lib(QStringLiteral("kf5/frameworkintegrationplugin"));
+        QPluginLoader lib(QStringLiteral("kf5/FrameworkIntegrationPlugin"));
         QObject *rootObj = lib.instance();
         if (rootObj) {
             s_dontAskAgainInterface = rootObj->property(KMESSAGEBOXDONTASKAGAIN_PROPERTY).value<KMessageBoxDontAskAgainInterface *>();
-- 
1.8.1.2


From 487c9908b99c8ee6636ef0250ec63cebaa3c3858 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Aur=C3=A9lien=20G=C3=A2teau?= <agateau@kde.org>
Date: Wed, 16 Oct 2013 14:40:25 +0200
Subject: [PATCH 3/4] Introduce KMessageBoxNotifyInterface

---
 tier1/kwidgetsaddons/src/kmessagebox.cpp           | 43 +++------------------
 tier1/kwidgetsaddons/src/kmessagebox.h             |  8 ++++
 tier1/kwidgetsaddons/src/kmessagebox_p.cpp         | 25 ++++++++++++
 tier1/kwidgetsaddons/src/kmessagebox_p.h           |  3 ++
 .../src/kmessageboxnotifyinterface.h               | 44 ++++++++++++++++++++++
 5 files changed, 85 insertions(+), 38 deletions(-)
 create mode 100644 tier1/kwidgetsaddons/src/kmessageboxnotifyinterface.h

diff --git a/tier1/kwidgetsaddons/src/kmessagebox.cpp b/tier1/kwidgetsaddons/src/kmessagebox.cpp
index 1cb18f0..0e99976 100644
--- a/tier1/kwidgetsaddons/src/kmessagebox.cpp
+++ b/tier1/kwidgetsaddons/src/kmessagebox.cpp
@@ -117,43 +117,6 @@ static QIcon themedMessageBoxIcon(QMessageBox::Icon icon)
    }
 }
 
-static void sendNotification( QString message, //krazy:exclude=passbyvalue
-                              const QStringList& strlist,
-                              QMessageBox::Icon icon,
-                              WId parent_id )
-{
-    // create the message for KNotify
-    QString messageType;
-    switch (icon) {
-    case QMessageBox::Warning:
-        messageType = QStringLiteral("messageWarning");
-        break;
-    case QMessageBox::Critical:
-        messageType = QStringLiteral("messageCritical");
-        break;
-    case QMessageBox::Question:
-        messageType = QStringLiteral("messageQuestion");
-        break;
-    default:
-        messageType = QStringLiteral("messageInformation");
-        break;
-    }
-
-    if ( !strlist.isEmpty() ) {
-        for ( QStringList::ConstIterator it = strlist.begin(); it != strlist.end(); ++it ) {
-            message += QLatin1Char('\n') + *it;
-        }
-    }
-
-#if 0
-    // NOTE waiting for the notification framework plan
-    if ( !message.isEmpty() ) {
-        KNotification::event( messageType, message, QPixmap(), QWidget::find( parent_id ),
-                              KNotification::DefaultEvent | KNotification::CloseOnTimeout );
-    }
-#endif
-}
-
 static void applyOptions( QDialog* dialog, KMessageBox::Options options )
 {
     if ( options & KMessageBox::WindowModal ) {
@@ -412,7 +375,11 @@ QDialogButtonBox::StandardButton createKMessageBox(QDialog *dialog, QDialogButto
 
 #ifndef Q_OS_WIN // FIXME problems with KNotify on Windows
     if ((options & KMessageBox::Notify)) {
-        sendNotification(text, strlist, notifyType, dialog->topLevelWidget()->winId());
+        QString message = text;
+        if (!strlist.isEmpty()) {
+            message += QLatin1Char('\n') + strlist.join(QLatin1Char('\n'));
+        }
+        notifyInterface()->sendNotification(notifyType, message, dialog->topLevelWidget());
     }
 #endif
 
diff --git a/tier1/kwidgetsaddons/src/kmessagebox.h b/tier1/kwidgetsaddons/src/kmessagebox.h
index f7ebe51..4d3c7cf 100644
--- a/tier1/kwidgetsaddons/src/kmessagebox.h
+++ b/tier1/kwidgetsaddons/src/kmessagebox.h
@@ -31,6 +31,7 @@
 #include <kwidgetsaddons_export.h>
 
 class KMessageBoxDontAskAgainInterface;
+class KMessageBoxNotifyInterface;
 class QDialog;
 class QDialogButtonBox;
 class QWidget;
@@ -795,6 +796,13 @@ namespace KMessageBox
     KWIDGETSADDONS_EXPORT void setDontShowAgainInterface(KMessageBoxDontAskAgainInterface* dontAskAgainInterface);
 
     /**
+     * Use @p notifyInterface to send notifications
+     *
+     * @since 5.0
+     */
+    KWIDGETSADDONS_EXPORT void setNotifyInterface(KMessageBoxNotifyInterface *notifyInterface);
+
+    /**
      * Create content and layout of a standard dialog
      *
      * @param dialog  The parent dialog base
diff --git a/tier1/kwidgetsaddons/src/kmessagebox_p.cpp b/tier1/kwidgetsaddons/src/kmessagebox_p.cpp
index 81a0bf6..b4ecb3e 100644
--- a/tier1/kwidgetsaddons/src/kmessagebox_p.cpp
+++ b/tier1/kwidgetsaddons/src/kmessagebox_p.cpp
@@ -61,8 +61,15 @@ private:
     QHash<QString, KMessageBox::ButtonCode> m_saved;
 };
 
+class KMessageBoxNotifyDummy : public KMessageBoxNotifyInterface
+{
+public:
+    void sendNotification(QMessageBox::Icon /*notificationType*/, const QString &/*message*/, QWidget */*parent*/) {}
+};
+
 // TODO should we use QSharedPointer here?
 static KMessageBoxDontAskAgainInterface* s_dontAskAgainInterface = 0;
+static KMessageBoxNotifyInterface* s_notifyInterface = 0;
 
 static void loadKMessageBoxPlugin()
 {
@@ -74,12 +81,16 @@ static void loadKMessageBoxPlugin()
         QObject *rootObj = lib.instance();
         if (rootObj) {
             s_dontAskAgainInterface = rootObj->property(KMESSAGEBOXDONTASKAGAIN_PROPERTY).value<KMessageBoxDontAskAgainInterface *>();
+            s_notifyInterface = rootObj->property(KMESSAGEBOXNOTIFY_PROPERTY).value<KMessageBoxNotifyInterface *>();
         }
     }
     // TODO use Qt-5.1's Q_GLOBAL_STATIC
     if (!s_dontAskAgainInterface) {
         s_dontAskAgainInterface = new KMessageBoxDontAskAgainMemoryStorage;
     }
+    if (!s_notifyInterface) {
+        s_notifyInterface = new KMessageBoxNotifyDummy;
+    }
 }
 
 KMessageBoxDontAskAgainInterface *dontAskAgainInterface()
@@ -90,6 +101,14 @@ KMessageBoxDontAskAgainInterface *dontAskAgainInterface()
     return s_dontAskAgainInterface;
 }
 
+KMessageBoxNotifyInterface *notifyInterface()
+{
+    if (!s_notifyInterface) {
+        loadKMessageBoxPlugin();
+    }
+    return s_notifyInterface;
+}
+
 void setDontShowAgainInterface(KMessageBoxDontAskAgainInterface* dontAskAgainInterface)
 {
     Q_ASSERT(dontAskAgainInterface != 0);
@@ -97,4 +116,10 @@ void setDontShowAgainInterface(KMessageBoxDontAskAgainInterface* dontAskAgainInt
     s_dontAskAgainInterface = dontAskAgainInterface;
 }
 
+void setNotifyInterface(KMessageBoxNotifyInterface *notifyInterface)
+{
+    Q_ASSERT(notifyInterface != 0);
+    s_notifyInterface = notifyInterface;
+}
+
 } // KMessageBox namespace
diff --git a/tier1/kwidgetsaddons/src/kmessagebox_p.h b/tier1/kwidgetsaddons/src/kmessagebox_p.h
index 77948ad..54cc5f5 100644
--- a/tier1/kwidgetsaddons/src/kmessagebox_p.h
+++ b/tier1/kwidgetsaddons/src/kmessagebox_p.h
@@ -21,11 +21,14 @@
 #define KMESSAGEBOX_P_H
 
 #include <kmessageboxdontaskagaininterface.h>
+#include <kmessageboxnotifyinterface.h>
 
 namespace KMessageBox {
 
 KMessageBoxDontAskAgainInterface *dontAskAgainInterface();
 
+KMessageBoxNotifyInterface *notifyInterface();
+
 } // KMessageBox
 
 #endif /* KMESSAGEBOX_P_H */
diff --git a/tier1/kwidgetsaddons/src/kmessageboxnotifyinterface.h b/tier1/kwidgetsaddons/src/kmessageboxnotifyinterface.h
new file mode 100644
index 0000000..fb1361b
--- /dev/null
+++ b/tier1/kwidgetsaddons/src/kmessageboxnotifyinterface.h
@@ -0,0 +1,44 @@
+/*  This file is part of the KDE libraries
+ *  Copyright 2013 Aurélien Gâteau <agateau@kde.org>
+ *
+ *  This library is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU Lesser General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License or ( at
+ *  your option ) version 3 or, at the discretion of KDE e.V. ( which shall
+ *  act as a proxy as in section 14 of the GPLv3 ), any later version.
+ *
+ *  This library is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *  Library General Public License for more details.
+ *
+ *  You should have received a copy of the GNU Lesser General Public License
+ *  along with this library; see the file COPYING.LIB.  If not, write to
+ *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
+ */
+
+#ifndef KMESSAGEBOXNOTIFYINTERFACE_H
+#define KMESSAGEBOXNOTIFYINTERFACE_H
+
+#include "kmessagebox.h"
+#include <qmetatype.h>
+
+/**
+ * @internal
+ * Used internally by KMessageBox, implemented by plugin, for dynamic dependency on KNotification.
+ */
+class KMessageBoxNotifyInterface
+{
+public:
+    KMessageBoxNotifyInterface() {}
+    virtual ~KMessageBoxNotifyInterface() {}
+
+    virtual void sendNotification(QMessageBox::Icon notificationType, const QString &message, QWidget *parent) = 0;
+};
+
+Q_DECLARE_METATYPE(KMessageBoxNotifyInterface *)
+
+#define KMESSAGEBOXNOTIFY_PROPERTY "KMessageBoxNotify"
+
+#endif
-- 
1.8.1.2


From 49adc70e960b5dd85f6cab631fb45019709ac746 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Aur=C3=A9lien=20G=C3=A2teau?= <agateau@kde.org>
Date: Wed, 16 Oct 2013 15:31:38 +0200
Subject: [PATCH 4/4] Implement KMessageBoxNotifyInterface

---
 KDE5PORTING.html                                   | 18 ++++++++--------
 .../src/integrationplugin/CMakeLists.txt           |  2 +-
 .../frameworkintegrationplugin.cpp                 | 25 ++++++++++++++++++++++
 .../integrationplugin/frameworkintegrationplugin.h |  8 +++++++
 4 files changed, 43 insertions(+), 10 deletions(-)

diff --git a/KDE5PORTING.html b/KDE5PORTING.html
index acb408c..68f38c1 100644
--- a/KDE5PORTING.html
+++ b/KDE5PORTING.html
@@ -327,16 +327,16 @@ have to find an alternative</li>
     m_naturalSorting = g.readEntry("NaturalSorting", true);
 </pre>
 </li>
-<li>KMessageBox is no longer a class, but a namespace, as it only had static methods. The KMessageBox namespace spans now in two frameworks:
+<li>KMessageBox changes:
     <ul>
-    <li>Queued methods are now in kmessagebox_queued.h from kde4support framework</li>
-    <li>The remainder of the methods are now in kmessagebox.h from kwidgetsaddons
-        <ul>
-            <li>setDontShowAskAgainConfig was renamed to setDontShowAgainConfig</li>
-            <li>NOTE: KMessageBox no longer uses notifications</li>
-        </ul>
-    </li>
-    <li>KMessageBox methods now return enums instead of ints. While code using int will continue to build, you are encouraged to switch to enums for better type safety.</li>
+        <li>KMessageBox is no longer a class, but a namespace, as it only had static methods. The KMessageBox namespace spans now in two frameworks:
+            <ul>
+                <li>Queued methods are now in kmessagebox_queued.h from kde4support framework</li>
+                <li>The remainder of the methods are now in kmessagebox.h from kwidgetsaddons</li>
+            </ul>
+        </li>
+        <li>setDontShowAskAgainConfig was renamed to setDontShowAgainConfig</li>
+        <li>KMessageBox methods now return enums instead of ints. While code using int will continue to build, you are encouraged to switch to enums for better type safety.</li>
     </ul>
 </li>
 <li>KMessageBoxMessageHandler moved to kde4support</li>
diff --git a/staging/frameworkintegration/src/integrationplugin/CMakeLists.txt b/staging/frameworkintegration/src/integrationplugin/CMakeLists.txt
index d8305bf..892f604 100644
--- a/staging/frameworkintegration/src/integrationplugin/CMakeLists.txt
+++ b/staging/frameworkintegration/src/integrationplugin/CMakeLists.txt
@@ -4,6 +4,6 @@ set(plugin_SRCS frameworkintegrationplugin.cpp)
 add_library(FrameworkIntegrationPlugin MODULE ${plugin_SRCS})
 set_target_properties(FrameworkIntegrationPlugin PROPERTIES PREFIX "") # remove lib prefix
 
-target_link_libraries(FrameworkIntegrationPlugin LINK_PRIVATE KF5::KWidgetsAddons KF5::KConfigCore)
+target_link_libraries(FrameworkIntegrationPlugin LINK_PRIVATE KF5::KWidgetsAddons KF5::KConfigCore KF5::KNotifications)
 
 install(TARGETS FrameworkIntegrationPlugin DESTINATION ${QT_PLUGIN_INSTALL_DIR}/kf5)
diff --git a/staging/frameworkintegration/src/integrationplugin/frameworkintegrationplugin.cpp b/staging/frameworkintegration/src/integrationplugin/frameworkintegrationplugin.cpp
index b8f5fa7..acc827c 100644
--- a/staging/frameworkintegration/src/integrationplugin/frameworkintegrationplugin.cpp
+++ b/staging/frameworkintegration/src/integrationplugin/frameworkintegrationplugin.cpp
@@ -21,6 +21,8 @@
 #include "frameworkintegrationplugin.h"
 #include <kconfiggroup.h>
 #include <ksharedconfig.h>
+#include <knotification.h>
+
 #include <qplugin.h>
 #include <QDebug>
 
@@ -105,8 +107,31 @@ void KMessageBoxDontAskAgainConfigStorage::enableMessage(const QString &dontShow
    config->sync();
 }
 
+void KMessageBoxNotify::sendNotification(QMessageBox::Icon notificationType, const QString &message, QWidget *parent)
+{
+    QString messageType;
+    switch (notificationType) {
+    case QMessageBox::Warning:
+        messageType = QStringLiteral("messageWarning");
+        break;
+    case QMessageBox::Critical:
+        messageType = QStringLiteral("messageCritical");
+        break;
+    case QMessageBox::Question:
+        messageType = QStringLiteral("messageQuestion");
+        break;
+    default:
+        messageType = QStringLiteral("messageInformation");
+        break;
+    }
+
+    KNotification::event(messageType, message, QPixmap(), parent,
+        KNotification::DefaultEvent | KNotification::CloseOnTimeout);
+}
+
 KFrameworkIntegrationPlugin::KFrameworkIntegrationPlugin()
     : QObject()
 {
     setProperty(KMESSAGEBOXDONTASKAGAIN_PROPERTY, QVariant::fromValue<KMessageBoxDontAskAgainInterface *>(&m_dontAskAgainConfigStorage));
+    setProperty(KMESSAGEBOXNOTIFY_PROPERTY, QVariant::fromValue<KMessageBoxNotifyInterface *>(&m_notify));
 }
diff --git a/staging/frameworkintegration/src/integrationplugin/frameworkintegrationplugin.h b/staging/frameworkintegration/src/integrationplugin/frameworkintegrationplugin.h
index ccf44d6..f415995 100644
--- a/staging/frameworkintegration/src/integrationplugin/frameworkintegrationplugin.h
+++ b/staging/frameworkintegration/src/integrationplugin/frameworkintegrationplugin.h
@@ -20,6 +20,7 @@
 
 #include <QObject>
 #include <kmessageboxdontaskagaininterface.h>
+#include <kmessageboxnotifyinterface.h>
 
 class KConfig;
 
@@ -41,6 +42,12 @@ private:
     KConfig* KMessageBox_againConfig;
 };
 
+class KMessageBoxNotify : public KMessageBoxNotifyInterface
+{
+public:
+    void sendNotification(QMessageBox::Icon notificationType, const QString &message, QWidget *parent) Q_DECL_OVERRIDE;
+};
+
 class KFrameworkIntegrationPlugin : public QObject
 {
 #if QT_VERSION >= 0x050000
@@ -53,5 +60,6 @@ public:
 
 private:
     KMessageBoxDontAskAgainConfigStorage m_dontAskAgainConfigStorage;
+    KMessageBoxNotify m_notify;
 };
 
-- 
1.8.1.2

